Index: trunk/kernel/mm/mapper.c
===================================================================
--- trunk/kernel/mm/mapper.c	(revision 690)
+++ trunk/kernel/mm/mapper.c	(revision 1)
@@ -132,830 +118,476 @@
     while( page != NULL );
 
-    // release the memory allocated to radix tree itself
-    grdxt_remote_destroy( rt_xp );
+    // release the memory allocated to radix-tree itself
+    grdxt_destroy( &mapper->radix );
 
     // release memory for mapper descriptor
-    kmem_remote_free( mapper_cxy , mapper_ptr , bits_log2(sizeof(mapper_t)) );
-
+    req.type = KMEM_MAPPER;
+    req.ptr  = mapper;
+    kmem_free( &req );
+
+    return 0;
+ 
 }  // end mapper_destroy()
 
-/////////////////////////////////////////////////
-error_t mapper_handle_miss( xptr_t     mapper_xp,
-                            uint32_t   page_id,
-                            xptr_t   * page_xp_ptr )
-{
-    error_t    error;
-
-    uint32_t   inode_size = 0;    
-    uint32_t   inode_type = 0;
-
-#if DEBUG_MAPPER_HANDLE_MISS || DEBUG_MAPPER_ERROR
-thread_t * this  = CURRENT_THREAD;
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-#endif
-
-    // get target mapper cluster and local pointer
-    cxy_t         mapper_cxy = GET_CXY( mapper_xp );
-    mapper_t    * mapper_ptr = GET_PTR( mapper_xp );
-
-    // get inode pointer
-    vfs_inode_t * inode = hal_remote_lpt( XPTR( mapper_cxy , &mapper_ptr->inode ) );
-
-    // get inode size and type if relevant
-    if( inode != NULL )
-    {
-        inode_size = hal_remote_l32( XPTR( mapper_cxy , &inode->size ) );
-        inode_type = hal_remote_l32( XPTR( mapper_cxy , &inode->type ) );
-    }
-
-#if DEBUG_MAPPER_HANDLE_MISS
-char          name[CONFIG_VFS_MAX_NAME_LENGTH];
-if( (DEBUG_MAPPER_HANDLE_MISS < cycle) && (inode != NULL) )
-{
-    vfs_inode_get_name( XPTR( mapper_cxy , inode ) , name );
-    printk("\n[%s] thread[%x,%x] enter for page %d in <%s> / cxy %x / cycle %d\n",
-    __FUNCTION__, this->process->pid, this->trdid, page_id, name, mapper_cxy, cycle );
-}
-if( (DEBUG_MAPPER_HANDLE_MISS < cycle) && (inode == NULL) )
-{
-    printk("\n[%s] thread[%x,%x] enter for page %d in FAT / cxy %x / cycle %d\n",
-    __FUNCTION__, this->process->pid, this->trdid, page_id, mapper_cxy, cycle );
-}
-#endif
-
-#if( DEBUG_MAPPER_HANDLE_MISS & 1 ) 
-if( DEBUG_MAPPER_HANDLE_MISS < cycle ) 
-{
-    if (inode != NULL) grdxt_remote_display( XPTR( mapper_cxy , &mapper_ptr->rt ) , name );
-    else               grdxt_remote_display( XPTR( mapper_cxy , &mapper_ptr->rt ) , "FAT" );
-}
-#endif
-
-    // allocate one 4 Kbytes page in the remote mapper cluster
-    void * base_ptr = kmem_remote_alloc( mapper_cxy , 12 , AF_NONE );
-
-    if( base_ptr == NULL )
-    {
-
-#if DEBUG_MAPPER_ERROR
-printk("\n[ERROR] in %s : thread [%x,%x] cannot allocate page in cluster %x / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid , mapper_cxy , cycle );
-#endif
-        return -1;
-    }
-
-    // get pointers on allocated page descrptor
-    xptr_t   page_xp  = ppm_base2page( XPTR( mapper_cxy , base_ptr ) );
-    page_t * page_ptr = GET_PTR( page_xp );
-
-    // initialize the page descriptor 
-    page_remote_init( page_xp );
-
-    // initialize specific page descriptor fields
-    hal_remote_s32( XPTR( mapper_cxy , &page_ptr->refcount ) , 1          );
-    hal_remote_s32( XPTR( mapper_cxy , &page_ptr->index )    , page_id    );
-    hal_remote_spt( XPTR( mapper_cxy , &page_ptr->mapper )   , mapper_ptr );
-    hal_remote_s32( XPTR( mapper_cxy , &page_ptr->flags )    , PG_INIT    );
-
-    // insert page in mapper radix tree 
-    error = grdxt_remote_insert( XPTR( mapper_cxy , &mapper_ptr->rt),
-                                 page_id,
-                                 page_ptr );
-    if( error )
-    {
-
-#if DEBUG_MAPPER_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot insert page in mapper / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid , cycle );
-ppm_remote_free_pages( mapper_cxy , page_ptr );
-#endif
-        return -1;
-    }
-
-    // launch I/O operation to load page from IOC device when required:
-    // - it is the FAT mapper
-    // - it is a directory mapper
-    // - it is a file mapper, and it exist data on IOC device for this page
-    if( (inode == NULL) || (inode_type == FILE_TYPE_DIR) || (inode_size > (page_id << 10) ) )
-    {
-        error = vfs_fs_move_page( page_xp , IOC_SYNC_READ );
-
-        if( error )
-        {
-
-#if DEBUG_MAPPER_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot load page from device / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid , cycle );
-mapper_remote_release_page( mapper_xp , page_ptr );
-#endif
-            return -1;
-         }
-    }
-
-    // return extended pointer on allocated page
-    *page_xp_ptr = page_xp;
-
-#if DEBUG_MAPPER_HANDLE_MISS
-ppn_t ppn = ppm_page2ppn( page_xp );
-if( (DEBUG_MAPPER_HANDLE_MISS < cycle) && (inode != NULL) )
-{
-    printk("\n[%s] thread[%x,%x] exit for page %d in <%s> / page %x / ppn %x\n",
-    __FUNCTION__, this->process->pid, this->trdid, page_id, name, page_ptr, ppn );
-}
-if( (DEBUG_MAPPER_HANDLE_MISS < cycle) && (inode == NULL) )
-{
-    printk("\n[%s] thread[%x,%x] exit for page %d in FAT / page %x / ppn %x\n",
-    __FUNCTION__, this->process->pid, this->trdid, page_id, page_ptr, ppn );
-}
-#endif
-
-#if( DEBUG_MAPPER_HANDLE_MISS & 1 ) 
-if( DEBUG_MAPPER_HANDLE_MISS < cycle ) 
-{
-    if (inode != NULL) grdxt_remote_display( XPTR( mapper_cxy , &mapper_ptr->rt ) , name );
-    else               grdxt_remote_display( XPTR( mapper_cxy , &mapper_ptr->rt ) , "FAT" );
-}
-#endif
-
-    return 0;
-
-}  // end mapper_handle_miss()
-
-/////////////////////////////////////////////
-xptr_t  mapper_get_page( xptr_t    mapper_xp,
-                         uint32_t  page_id )
-{
-    error_t       error;
+
+////////////////////////////////////////////
+page_t * mapper_get_page( mapper_t * mapper,
+                          uint32_t   index )
+{
+	kmem_req_t    req;
+	page_t      * page;
+	error_t       error;
 
     thread_t * this = CURRENT_THREAD;
 
-    // get mapper cluster and local pointer
-    mapper_t * mapper_ptr = GET_PTR( mapper_xp );
-    cxy_t      mapper_cxy = GET_CXY( mapper_xp );
-
-assert( __FUNCTION__, (hal_remote_lpt( XPTR( mapper_cxy , &mapper_ptr->inode ) ) != NULL ),
-"should not be used for the FAT mapper");
-
-#if DEBUG_MAPPER_GET_PAGE
-uint32_t      cycle = (uint32_t)hal_get_cycles();
-char          name[CONFIG_VFS_MAX_NAME_LENGTH];
-if( DEBUG_MAPPER_GET_PAGE < cycle )  
-{
-    vfs_inode_t * inode = hal_remote_lpt( XPTR( mapper_cxy , &mapper_ptr->inode ) );
-    vfs_inode_get_name( XPTR( mapper_cxy , inode ) , name );
-    printk("\n[%s] thread[%x,%x] enter for page %d of <%s> mapper / cycle %d\n",
-    __FUNCTION__, this->process->pid, this->trdid, page_id, name, cycle );
-}
-#endif
-
-#if( DEBUG_MAPPER_GET_PAGE & 1 )
-if( DEBUG_MAPPER_GET_PAGE < cycle ) 
-ppm_remote_display( local_cxy );
-#endif
-
-    // check thread can yield
-    thread_assert_can_yield( this , __FUNCTION__ );
-
-    // build extended pointer on mapper lock and mapper rt
-    xptr_t lock_xp  = XPTR( mapper_cxy , &mapper_ptr->lock );
-    xptr_t rt_xp    = XPTR( mapper_cxy , &mapper_ptr->rt );
-
     // take mapper lock in READ_MODE
-    remote_rwlock_rd_acquire( lock_xp );
+    rwlock_rd_lock( &mapper->lock );
 
     // search page in radix tree
-    xptr_t page_xp  = grdxt_remote_lookup( rt_xp , page_id );
-
-    // test mapper miss 
-    if( page_xp == XPTR_NULL )                  // miss => handle it
+    page = (page_t *)grdxt_lookup( &mapper->radix , index );
+
+    // test if page available in mapper 
+    if( ( page == NULL) || page_is_flag( page , PG_INLOAD ) )  // page not available            /
     {
         // release the lock in READ_MODE and take it in WRITE_MODE
-        remote_rwlock_rd_release( lock_xp );
-        remote_rwlock_wr_acquire( lock_xp );
-
-        // second test on missing page because the page status can be modified
+        rwlock_rd_unlock( &mapper->lock );
+        rwlock_wr_lock( &mapper->lock );
+
+        // second test on missing page because the page status can have been modified
         // by another thread, when passing from READ_MODE to WRITE_MODE.
         // from this point there is no concurrent accesses to mapper.
-        page_xp = grdxt_remote_lookup( rt_xp , page_id );
-
-        if ( page_xp == XPTR_NULL )  // miss confirmed => handle it
-        {
-            error = mapper_handle_miss( mapper_xp,
-                                        page_id,
-                                        &page_xp );
+
+        page = grdxt_lookup( &mapper->radix , index );
+
+        if ( page == NULL )   // missing page => load it from file system
+        {
+            // allocate one page from PPM
+            req.type  = KMEM_PAGE;
+            req.size  = 0;
+            req.flags = AF_NONE;
+            page = kmem_alloc( &req );
+      
+            if( page == NULL )
+            {
+                printk("\n[ERROR] in %s : thread %x cannot allocate a page in cluster %x\n",
+                       __FUNCTION__ , this->trdid , local_cxy );
+                rwlock_wr_unlock( &mapper->lock );
+                return NULL;
+            }
+
+            // initialize the page descriptor
+            page_init( page );
+            page_set_flag( page , PG_INIT );
+            page_set_flag( page , PG_INLOAD );
+            page_refcount_up( page );
+            page->mapper = mapper;
+            page->index  = index;
+
+            // insert page in mapper radix tree
+            error = grdxt_insert( &mapper->radix, index , page );
+
+            // release mapper lock from WRITE_MODE
+            rwlock_wr_unlock( &mapper->lock );
+
+            if( error ) 
+            {
+                printk("\n[ERROR] in %s : thread %x cannot insert page in mapper\n",
+                       __FUNCTION__ , this->trdid );
+                mapper_release_page( mapper , index , page );
+                page_clear_flag( page , PG_ALL );
+                req.ptr  = page;
+                req.type = KMEM_PAGE;
+                kmem_free(&req);
+                return NULL;
+            }
+        
+            // launch I/O operation to load page from file system
+            error = mapper_updt_page( mapper , index , page );
+
             if( error )
             {
-
-#if DEBUG_MAPPER_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot handle mapper miss\n",
-__FUNCTION__ , this->process->pid, this->trdid );
-remote_rwlock_wr_release( lock_xp );
-#endif
-                return XPTR_NULL;
+                printk("\n[ERROR] in %s : thread %x cannot load page from device\n",
+                       __FUNCTION__ , this->trdid );
+                mapper_release_page( mapper , index , page );
+                page_clear_flag( page , PG_ALL );
+                req.ptr  = page;
+                req.type = KMEM_PAGE;
+                kmem_free( &req );
+                return NULL;
             }
-        }
-
-#if (DEBUG_MAPPER_GET_PAGE & 1)
-if( DEBUG_MAPPER_GET_PAGE < cycle )
-printk("\n[%s] thread[%x,%x] introduced missing page %d in <%s> mapper / ppn %x\n",
-__FUNCTION__, this->process->pid, this->trdid, page_id, name, ppm_page2ppn(page_xp) );
-#endif
+
+            // update the mapper and index fields in page descriptor
+            page->mapper = mapper;
+            page->index  = index;
+
+            // reset the page INLOAD flag to make the page available to all readers
+            page_clear_flag( page , PG_INLOAD );
+
+        }
+        else if( page_is_flag( page , PG_INLOAD ) )   // page is loaded by another thread
+        {
+            // release mapper lock from WRITE_MODE
+            rwlock_wr_unlock( &mapper->lock );
+
+            // deschedule to wait load completion
+            while( 1 )
+            {
+                // exit waiting loop when loaded
+                if(  page_is_flag( page , PG_INLOAD ) ) break;
+
+                // deschedule 
+                sched_yield();
+            }
+         
+        }
+
+        return page;
+    }
+    else 
+    {
+         // release lock from READ_MODE
+         rwlock_rd_unlock( &mapper->lock );
+
+         return page;
+    }
+}  // end mapper_get_page()
+
+///////////////////////////////////////////////
+error_t mapper_release_page( mapper_t * mapper,
+                             uint32_t   index,
+                             page_t   * page )
+{
+    error_t error;
+
+    // lauch IO operation to update page to file system
+    error = mapper_sync_page( mapper , index , page );
+
+    if( error )
+    {
+        printk("\n[ERROR] in %s : cannot update file system\n", __FUNCTION__ );
+        return EIO;
+    }
         
-        // release mapper lock from WRITE_MODE
-        remote_rwlock_wr_release( lock_xp );
-    }
-    else                                              // hit 
-    {
+    // take mapper lock in WRITE_MODE
+    rwlock_wr_lock( &mapper->lock );
+
+    // remove physical page from radix tree
+	grdxt_remove( &mapper->radix , page->index );
+
+    // release mapper lock from WRITE_MODE
+    rwlock_wr_unlock( &mapper->lock );
+
+    // release page to PPM
+	kmem_req_t   req;
+	req.type  = KMEM_PAGE;
+    req.ptr   = page;
+    kmem_free( &req );
+
+    return 0;
+
+}  // end mapper_release_page()
+
+////////////////////////////////////////////
+error_t mapper_updt_page( mapper_t * mapper,
+                          uint32_t   index,
+                          page_t   * page )
+{
+    uint32_t      type;
+    vfs_inode_t * inode;
+    error_t       error = 0;
+
+    if( page == NULL )
+    {
+        printk("\n[PANIC] in %s : page pointer is NULL\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    if( mapper == NULL )
+    {
+        printk("\n[PANIC] in %s : no mapper for this page\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // get file system type and inode pointer
+    inode = mapper->inode;
+    type  = inode->ctx->type;
+
+    // get page lock
+    page_lock( page );
+
+    // get mapper lock in WRITE_MODE
+    rwlock_wr_lock( &mapper->lock );
+
+    // call proper I/O operation to update file system
+    if     ( type == FS_TYPE_FATFS ) error = fatfs_read_page( page );
+    else if( type == FS_TYPE_RAMFS ) error = ramfs_read_page( page );
+    else
+    {
+        printk("\n[PANIC] in %s : undefined file system type\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // release mapper lock from WRITE_MODE
+    rwlock_wr_unlock( &mapper->lock );
+
+    // release page lock 
+    page_unlock( page );
+
+    if( error )
+    {
+        printk("\n[PANIC] in %s : cannot access file system\n", __FUNCTION__ );
+        return EIO;
+    }
+	
+    return 0;
+}  // end mapper_updt_page
+
+////////////////////////////////////////////
+error_t mapper_sync_page( mapper_t * mapper,
+                          uint32_t   index,
+                          page_t   * page )
+{
+    uint32_t      type;
+    vfs_inode_t * inode;
+    error_t       error = 0;
+
+    if( page == NULL )
+    {
+        printk("\n[PANIC] in %s : page pointer is NULL\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    if( mapper == NULL )
+    {
+        printk("\n[PANIC] in %s : no mapper for this page\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+	if( page_is_flag( page , PG_DIRTY ) ) 
+	{
+        // get file system type and inode pointer
+        inode = mapper->inode;
+        type  = inode->ctx->type;
+
+        // get page lock
+        page_lock( page );
+
+        // get mapper lock in READ_MODE
+        rwlock_rd_lock( &mapper->lock );
+
+        // call proper I/O operation to update file system
+        if     ( type == FS_TYPE_FATFS ) error = fatfs_write_page( page );
+        else if( type == FS_TYPE_RAMFS ) error = ramfs_write_page( page );
+        else
+        {
+            printk("\n[PANIC] in %s : undefined file system type\n", __FUNCTION__ );
+            hal_core_sleep();
+        }
+
         // release mapper lock from READ_MODE
-        remote_rwlock_rd_release( lock_xp );
-    }
-
-#if DEBUG_MAPPER_GET_PAGE
-if( DEBUG_MAPPER_GET_PAGE < cycle )
-printk("\n[%s] thread[%x,%x] exit for page %d of <%s> mapper / ppn %x\n",
-__FUNCTION__, this->process->pid, this->trdid, page_id, name, ppm_page2ppn(page_xp) );
-#endif
-
-#if( DEBUG_MAPPER_GET_PAGE & 1)
-if( DEBUG_MAPPER_GET_PAGE < cycle ) 
-ppm_remote_display( local_cxy );
-#endif
-
-    return page_xp;
-
-}  // end mapper_get_page()
-
-/////////////////////////////////////////////////
-xptr_t  mapper_get_fat_page( xptr_t    mapper_xp,
-                             uint32_t  page_id )
-{
-    error_t       error;
-
-    thread_t * this = CURRENT_THREAD;
-
-    // get mapper cluster and local pointer
-    mapper_t * mapper_ptr = GET_PTR( mapper_xp );
-    cxy_t      mapper_cxy = GET_CXY( mapper_xp );
-
-assert( __FUNCTION__, (hal_remote_lpt( XPTR( mapper_cxy , &mapper_ptr->inode ) ) == NULL ),
-"should be used for the FAT mapper");
-
-#if DEBUG_MAPPER_GET_FAT_PAGE
-uint32_t      cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_MAPPER_GET_FAT_PAGE < cycle ) 
-printk("\n[%s] thread[%x,%x] enter for page %d of FAT mapper / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, page_id, cycle );
-#endif
-
-#if( DEBUG_MAPPER_GET_FAT_PAGE & 2 )
-if( DEBUG_MAPPER_GET_FAT_PAGE < cycle ) 
-ppm_remote_display( local_cxy );
-#endif
-
-    // check thread can yield
-    thread_assert_can_yield( this , __FUNCTION__ );
-
-    // build extended pointer on mapper lock and mapper rt
-    xptr_t lock_xp  = XPTR( mapper_cxy , &mapper_ptr->lock );
-    xptr_t rt_xp    = XPTR( mapper_cxy , &mapper_ptr->rt );
-
-    // take mapper lock in READ_MODE
-    remote_rwlock_rd_acquire( lock_xp );
-
-    // search page in radix tree
-    xptr_t page_xp  = grdxt_remote_lookup( rt_xp , page_id );
-
-    // test mapper miss 
-    if( page_xp == XPTR_NULL )                  // miss => handle it
-    {
-        // release the lock in READ_MODE and take it in WRITE_MODE
-        remote_rwlock_rd_release( lock_xp );
-        remote_rwlock_wr_acquire( lock_xp );
-
-        // second test on missing page because the page status can be modified
-        // by another thread, when passing from READ_MODE to WRITE_MODE.
-        // from this point there is no concurrent accesses to mapper.
-        page_xp = grdxt_remote_lookup( rt_xp , page_id );
-
-        if ( page_xp == XPTR_NULL )  // miss confirmed => handle it
-        {
-            error = mapper_handle_miss( mapper_xp,
-                                        page_id,
-                                        &page_xp );
-            if( error )
-            {
-
-#if DEBUG_MAPPER_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot handle mapper miss\n",
-__FUNCTION__ , this->process->pid, this->trdid );
-remote_rwlock_wr_release( lock_xp );
-#endif
-                return XPTR_NULL;
-            }
-        }
-
-#if (DEBUG_MAPPER_GET_FAT_PAGE & 1)
-if( DEBUG_MAPPER_GET_FAT_PAGE < cycle )
-printk("\n[%s] thread[%x,%x] introduced missing page %d in FAT mapper / ppn %x\n",
-__FUNCTION__, this->process->pid, this->trdid, page_id, ppm_page2ppn(page_xp) );
-#endif
-        
-        // release mapper lock from WRITE_MODE
-        remote_rwlock_wr_release( lock_xp );
-    }
-    else                                              // hit 
-    {
-        // release mapper lock from READ_MODE
-        remote_rwlock_rd_release( lock_xp );
-    }
-
-#if DEBUG_MAPPER_GET_FAT_PAGE
-if( DEBUG_MAPPER_GET_FAT_PAGE < cycle )
-printk("\n[%s] thread[%x,%x] exit for page %d of FAT mapper  / ppn %x\n",
-__FUNCTION__, this->process->pid, this->trdid, page_id, ppm_page2ppn(page_xp) );
-#endif
-
-#if( DEBUG_MAPPER_GET_FAT_PAGE & 1)
-if( DEBUG_MAPPER_GET_FAT_PAGE < cycle ) 
-ppm_remote_display( local_cxy );
-#endif
-
-    return page_xp;
-
-}  // end mapper_get_fat_page()
-
-////////////////////////////////////////////////////
-void mapper_remote_release_page( xptr_t   mapper_xp,
-                                 page_t * page )
-{
-    // get mapper cluster an local pointer
-    cxy_t      mapper_cxy = GET_CXY( mapper_xp );
-    mapper_t * mapper_ptr = GET_PTR( mapper_xp );
-
-    // build extended pointer on mapper lock
-    xptr_t lock_xp = XPTR( mapper_cxy , &mapper_ptr->lock );
-
-    // take mapper lock in WRITE_MODE
-    remote_rwlock_wr_acquire( lock_xp );
-
-    // remove physical page from radix tree
-    grdxt_remote_remove( XPTR( mapper_cxy , &mapper_ptr->rt ) , page->index );
-
-    // release mapper lock from WRITE_MODE
-    remote_rwlock_wr_release( lock_xp );
-
-    // release page to PPM
-    ppm_remote_free_pages( mapper_cxy , page );
-                           
-}  // end mapper_release_page()
-
-///////////////////////////////////////////////
-error_t mapper_move_user( xptr_t     mapper_xp,
-                          bool_t     to_buffer,
-                          uint32_t   file_offset,
-                          void     * buffer,
-                          uint32_t   size )
-{
-    uint32_t   page_offset;    // first byte to move to/from a mapper page
-    uint32_t   page_bytes;     // number of bytes to move to/from a mapper page
-    uint32_t   page_id;        // current mapper page index
-    uint32_t   done;           // number of moved bytes
-    xptr_t     page_xp;        // extended pointer on current mapper page descriptor
-
-#if DEBUG_MAPPER_MOVE_USER
-uint32_t      cycle      = (uint32_t)hal_get_cycles();
-thread_t    * this       = CURRENT_THREAD;
-cxy_t         mapper_cxy = GET_CXY( mapper_xp );
-mapper_t    * mapper_ptr = GET_PTR( mapper_xp );
-vfs_inode_t * inode_ptr  = hal_remote_lpt( XPTR( mapper_cxy , &mapper_ptr->inode ) );
-xptr_t        inode_xp   = XPTR( mapper_cxy , inode_ptr );
-char          name[CONFIG_VFS_MAX_NAME_LENGTH];
-vfs_inode_get_name( inode_xp , name );
-if( DEBUG_MAPPER_MOVE_USER < cycle )
-{
-    if( to_buffer )
-    printk("\n[%s] thread[%x,%x] : mapper(%s) -> buffer(%x) / bytes %d / cycle %d\n",
-    __FUNCTION__, this->process->pid, this->trdid, name, buffer, size, cycle );
-    else
-    printk("\n[%s] thread[%x,%x] : buffer(%x) -> mapper(%s) / bytes %d / cycle %d\n",
-    __FUNCTION__, this->process->pid, this->trdid, buffer, name, size, cycle );
-}
-#endif
-
-    // compute indexes of first and last bytes in file
-    uint32_t min_byte = file_offset;
-    uint32_t max_byte = file_offset + size - 1;
+        rwlock_rd_unlock( &mapper->lock );
+
+        // release page lock 
+        page_unlock( page );
+
+        if( error )
+        {
+            printk("\n[PANIC] in %s : cannot update file system\n", __FUNCTION__ );
+            return EIO;
+        }
+    
+        // clear dirty bit
+		page_undo_dirty( page );
+     }
+	
+    return 0;
+
+}  // end mapper_sync_page()
+
+///////////////////////////////////////////////////////////////////////////////////////
+// This static function is called by the mapper_move fragments() function.
+// It moves one fragment between an user buffer and the kernel mapper.
+// Implementation Note: It can require access to one or two pages in mapper: 
+//  [max_page_index == min_page_index]     <=>  fragment fit in one mapper page
+//  [max_page index == min_page_index + 1] <=>  fragment spread on two mapper pages
+///////////////////////////////////////////////////////////////////////////////////////
+static error_t mapper_move_one_fragment( mapper_t   * mapper,
+                                         bool_t       to_buffer,
+                                         fragment_t * fragment )
+{
+    uint32_t   size;                 // number of bytes in fragment 
+    cxy_t      buf_cxy;              // cluster identifier for user buffer
+    uint8_t  * buf_ptr;              // local pointer on first byte in user buffer
+    
+    xptr_t     xp_buf;               // extended pointer on byte in user buffer
+    xptr_t     xp_map;               // extended pointer on byte in kernel mapper
+
+    uint32_t   min_file_offset;      // offset of first byte in file 
+    uint32_t   max_file_offset;      // offset of last byte in file    
+
+    uint32_t   first_page_index;     // index of first page in mapper
+    uint32_t   first_page_offset;    // offset of first byte in first page in mapper    
+    uint32_t   first_page_size;      // offset of first byte in first page in mapper    
+
+    uint32_t   second_page_index;    // index of last page in mapper    
+    uint32_t   second_page_offset;   // offset of last byte in last page in mapper    
+    uint32_t   second_page_size;     // offset of last byte in last page in mapper    
+ 
+    page_t   * page;                 // pointer on one page descriptor in mapper
+    uint8_t  * map_ptr;              // local pointer on first byte in mapper
+
+    // get fragment attributes in user buffer
+    buf_cxy = fragment->buf_cxy;
+    buf_ptr = fragment->buf_ptr;
+    size    = fragment->size;
+
+    if( size > CONFIG_PPM_PAGE_SIZE )
+    {
+        printk("\n[PANIC] in %s : illegal fragment size = %d\n",
+               __FUNCTION__ , size );
+        return EINVAL;
+    }
+    
+    // compute offsets of first and last bytes in file
+    min_file_offset = fragment->file_offset;
+    max_file_offset = min_file_offset + size;
 
     // compute indexes of pages for first and last byte in mapper
-    uint32_t first = min_byte >> CONFIG_PPM_PAGE_ORDER;
-    uint32_t last  = max_byte >> CONFIG_PPM_PAGE_ORDER;
-
-#if (DEBUG_MAPPER_MOVE_USER & 1)
-if( DEBUG_MAPPER_MOVE_USER < cycle )
-printk("\n[%s] thread[%x,%x] : mapper(%x,%x) / first_page %d / last_page %d\n",
-__FUNCTION__, this->process->pid, this->trdid, mapper_cxy, mapper_ptr, first, last );
-#endif
-
-    done = 0;
-
-    // loop on pages in mapper
-    for( page_id = first ; page_id <= last ; page_id++ )
-    {
-        // compute page_offset
-        if( page_id == first ) page_offset = min_byte & CONFIG_PPM_PAGE_MASK;
-        else                   page_offset = 0;
-
-        // compute number of bytes in page
-        if      ( first   == last  ) page_bytes = size;
-        else if ( page_id == first ) page_bytes = CONFIG_PPM_PAGE_SIZE - page_offset;
-        else if ( page_id == last  ) page_bytes = (max_byte & CONFIG_PPM_PAGE_MASK) + 1;
-        else                         page_bytes = CONFIG_PPM_PAGE_SIZE;
-
-#if (DEBUG_MAPPER_MOVE_USER & 1)
-if( DEBUG_MAPPER_MOVE_USER < cycle )
-printk("\n[%s] thread[%x,%x] : page_id %d / page_offset %d / bytes %d\n",
-__FUNCTION__, this->process->pid, this->trdid, page_id , page_offset , page_bytes );
-#endif
-
-        // get extended pointer on page descriptor in mapper
-        page_xp = mapper_get_page( mapper_xp , page_id ); 
-
-        if ( page_xp == XPTR_NULL ) return -1;
-
-        // compute extended pointer on kernel mapper
-        xptr_t     map_xp  = ppm_page2base( page_xp ) + page_offset;
-
-#if (DEBUG_MAPPER_MOVE_USER & 1)
-if( DEBUG_MAPPER_MOVE_USER < cycle )
-printk("\n[%s] thread[%x,%x] : get buffer(%x,%x) in mapper\n",
-__FUNCTION__, this->process->pid, this->trdid, GET_CXY(map_xp), GET_PTR(map_xp) );
-#endif
-        // compute pointer in user buffer
-        uint8_t * buf_ptr = (uint8_t *)buffer + done;
+    first_page_index  = min_file_offset >> CONFIG_PPM_PAGE_SHIFT;
+    second_page_index = max_file_offset >> CONFIG_PPM_PAGE_SHIFT;
+
+    if ( first_page_index == second_page_index )  // only one page in mapper
+    {
+        // compute offset and size for page in mapper 
+        first_page_offset = min_file_offset & (1<<CONFIG_PPM_PAGE_SHIFT);
+        first_page_size   = size;
+
+        // get pointer on first page in mapper
+        page = mapper_get_page( mapper , first_page_index );
+
+        if ( page == NULL ) return EINVAL;
+
+        // compute pointer on fragment first byte in mapper
+        map_ptr = (uint8_t *)ppm_page2base( page ) + first_page_offset;
+
+        // compute extended pointers in mapper and in buffer
+        xp_map = XPTR( local_cxy , map_ptr );
+        xp_buf = XPTR( buf_cxy , buf_ptr );
 
         // move fragment
         if( to_buffer )
         {
-            hal_copy_to_uspace( buf_ptr , map_xp , page_bytes ); 
-
-#if DEBUG_MAPPER_MOVE_USER & 1
-if( DEBUG_MAPPER_MOVE_USER < cycle )
-printk("\n[%s] thread[%x,%x] moved %d bytes / mapper %s (%x,%x) -> user buffer(%x,%x)\n",
-__FUNCTION__, this->process->pid, this->trdid, page_bytes,
-name, GET_CXY(map_xp), GET_PTR(map_xp), local_cxy, buf_ptr );
-#endif
-
+            hal_remote_memcpy( xp_buf , xp_map , first_page_size );
         }
         else
         {
-            ppm_page_do_dirty( page_xp ); 
-            hal_copy_from_uspace( map_xp , buf_ptr , page_bytes ); 
-
-#if DEBUG_MAPPER_MOVE_USER & 1
-if( DEBUG_MAPPER_MOVE_USER < cycle )
-printk("\n[%s] thread[%x,%x] moved %d bytes / user buffer(%x,%x) -> mapper %s (%x,%x)\n",
-__FUNCTION__, this->process->pid, this->trdid, page_bytes,
-local_cxy, buf_ptr, name, GET_CXY(map_xp), GET_PTR(map_xp) );
-mapper_display_page(  mapper_xp , page_id , 128 );
-#endif
-
-        }
-
-        done += page_bytes;
-    }
-
-#if DEBUG_MAPPER_MOVE_USER
-cycle      = (uint32_t)hal_get_cycles();
-if( DEBUG_MAPPER_MOVE_USER < cycle )
-{
-    if( to_buffer )
-    printk("\n[%s] thread[%x,%x] completed mapper(%s) -> buffer(%x) / cycle %d\n",
-    __FUNCTION__, this->process->pid, this->trdid, name, buffer, cycle );
-    else
-    printk("\n[%s] thread[%x,%x] completed buffer(%x) -> mapper(%s) / cycle %d\n",
-    __FUNCTION__, this->process->pid, this->trdid, buffer, name, cycle );
-}
-#endif
+            page_do_dirty( page );
+            hal_remote_memcpy( xp_map , xp_buf , first_page_size );
+        }
+    }
+    else                                        // two pages in mapper
+    {
+        // compute offset and size for first page in mapper
+        first_page_offset = min_file_offset & (1<<CONFIG_PPM_PAGE_SHIFT);
+        first_page_size   = CONFIG_PPM_PAGE_SIZE - first_page_offset;
+
+        // get pointer on first page descriptor in mapper
+        page = mapper_get_page( mapper , first_page_index );
+
+        if ( page == NULL ) return EINVAL;
+
+        // compute local pointer on first byte in first page in mapper
+        map_ptr = (uint8_t *)ppm_page2base(page) + first_page_offset;
+    
+        // compute extended pointers
+        xp_map = XPTR( local_cxy , map_ptr );
+        xp_buf = XPTR( buf_cxy , buf_ptr );
+
+        // move fragment to/from first page
+        if( to_buffer )
+        {
+            hal_remote_memcpy( xp_buf , xp_map , first_page_size );
+        }
+        else
+        {
+            page_do_dirty( page );
+            hal_remote_memcpy( xp_map , xp_buf , first_page_size );
+        }
+
+        // compute offset and size for second page in mapper
+        second_page_offset = 0;
+        second_page_size   = size - first_page_size;  
+
+        // get pointer on second page in mapper
+        page = mapper_get_page( mapper , second_page_index );
+
+        if ( page == NULL ) return EINVAL;
+
+        // compute local pointer on first byte in second page in mapper
+        map_ptr = (uint8_t *)ppm_page2base( page ) + second_page_offset;
+    
+        // compute extended pointers
+        xp_map = XPTR( local_cxy , map_ptr );
+        xp_buf = XPTR( buf_cxy , buf_ptr + first_page_offset );
+
+        // move fragment to/from second page
+        if( to_buffer )
+        {
+            hal_remote_memcpy( xp_buf , xp_map , second_page_size );
+        }
+        else
+        {
+            page_do_dirty( page );
+            hal_remote_memcpy( xp_map , xp_buf , second_page_size );
+        }
+    }
 
     return 0;
-
-}  // end mapper_move_user()
-
-////////////////////////////////////////////////
-error_t mapper_move_kernel( xptr_t    mapper_xp,
-                            bool_t    to_buffer,
-                            uint32_t  file_offset,
-                            xptr_t    buffer_xp,
-                            uint32_t  size )
-{
-    uint32_t   page_offset;    // first byte to move to/from a mapper page
-    uint32_t   page_bytes;     // number of bytes to move to/from a mapper page
-    uint32_t   page_id;        // current mapper page index
-    uint32_t   done;           // number of moved bytes
-    xptr_t     page_xp;        // extended pointer on current mapper page descriptor
-
-    uint8_t  * src_ptr;        // source buffer local pointer
-    cxy_t      src_cxy;        // source cluster
-    uint8_t  * dst_ptr;        // destination buffer local pointer
-    cxy_t      dst_cxy;        // destination cluster
-
-    // get buffer cluster and local pointer
-    cxy_t     buffer_cxy = GET_CXY( buffer_xp );
-    uint8_t * buffer_ptr = GET_PTR( buffer_xp );
-
-    // get mapper cluster
-    cxy_t     mapper_cxy = GET_CXY( mapper_xp );
-
-#if DEBUG_MAPPER_MOVE_KERNEL
-char          name[CONFIG_VFS_MAX_NAME_LENGTH];
-uint32_t      cycle  = (uint32_t)hal_get_cycles();
-thread_t    * this   = CURRENT_THREAD;
-mapper_t    * mapper = GET_PTR( mapper_xp );
-vfs_inode_t * inode  = hal_remote_lpt( XPTR( mapper_cxy , &mapper->inode ) );
-vfs_inode_get_name( XPTR( mapper_cxy , inode ) , name );
-if( DEBUG_MAPPER_MOVE_KERNEL < cycle )
-printk("\n[%s] thread[%x,%x] enter / %d bytes / offset %d / mapper <%s> / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, size, file_offset, name, cycle );
-#endif
-
-    // compute offsets of first and last bytes in file
-    uint32_t min_byte = file_offset;
-    uint32_t max_byte = file_offset + size -1;
-
-    // compute indexes for first and last pages in mapper
-    uint32_t first = min_byte >> CONFIG_PPM_PAGE_ORDER;
-    uint32_t last  = max_byte >> CONFIG_PPM_PAGE_ORDER;
-
-    // compute source and destination clusters
-    if( to_buffer )
-    {
-        dst_cxy = buffer_cxy;
-        src_cxy = mapper_cxy;
-    }
-    else
-    {
-        src_cxy = buffer_cxy;
-        dst_cxy = mapper_cxy;
-    }
-
-    done = 0;
-
-    // loop on pages in mapper
-    for( page_id = first ; page_id <= last ; page_id++ )
-    {
-        // compute page_offset
-        if( page_id == first ) page_offset = min_byte & CONFIG_PPM_PAGE_MASK;
-        else                   page_offset = 0;
-
-        // compute number of bytes to move in page
-        if      ( first == last  )   page_bytes = size;
-        else if ( page_id == first ) page_bytes = CONFIG_PPM_PAGE_SIZE - page_offset;
-        else if ( page_id == last  ) page_bytes = (max_byte & CONFIG_PPM_PAGE_MASK) + 1;
-        else                         page_bytes = CONFIG_PPM_PAGE_SIZE;
-
-        // get extended pointer on page descriptor
-        page_xp = mapper_get_page( mapper_xp , page_id );
-
-        if ( page_xp == XPTR_NULL ) return -1;
-
-        // get page base address
-        xptr_t    base_xp  = ppm_page2base( page_xp );
-        uint8_t * base_ptr = (uint8_t *)GET_PTR( base_xp );
-
-        // compute source and destination pointers
-        if( to_buffer )
-        {
-            dst_ptr = buffer_ptr + done;
-            src_ptr = base_ptr + page_offset;
-        }
-        else
-        {
-            src_ptr = buffer_ptr + done;
-            dst_ptr = base_ptr + page_offset;
-
-            ppm_page_do_dirty( page_xp );
-        }
-
-#if (DEBUG_MAPPER_MOVE_KERNEL & 1)
-if( DEBUG_MAPPER_MOVE_KERNEL < cycle )
-{
-    if( to_buffer )
-    printk("\n[%s] mapper <%s> page %d => buffer (%x,%x) / %d bytes\n",
-    __FUNCTION__, name, page_id, dst_cxy, dst_ptr, page_bytes );
-    else
-    printk("\n[%s] buffer (%x,%x) => mapper <%s> page %d / %d bytes\n",
-    __FUNCTION__, src_cxy, src_ptr, name, page_id, page_bytes );
-}
-#endif
-
-        // move fragment
-        hal_remote_memcpy( XPTR( dst_cxy , dst_ptr ), XPTR( src_cxy , src_ptr ), page_bytes );
-
-        done += page_bytes;
-    }
-
-#if DEBUG_MAPPER_MOVE_KERNEL
-cycle  = (uint32_t)hal_get_cycles();
-if( DEBUG_MAPPER_MOVE_KERNEL < cycle )
-printk("\n[%s] thread[%x,%x] exit / mapper <%s> / buffer (%x,%x) / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, name, buffer_cxy, buffer_ptr, cycle );
-#endif
+}  // end mapper_move_one_fragment()
+
+/////////////////////////////////////////////////
+error_t mapper_move_fragments( mapper_t * mapper,
+                               bool_t     read,
+                               uint32_t   nb_frags,
+                               xptr_t     xp_frags )
+{
+	uint32_t     index;
+	error_t      error;
+    fragment_t   local_frags[CONFIG_MAPPER_MAX_FRAGMENTS];   // local copy of fragments array
+    fragment_t * frags_array;                                // pointer on fragments array
+
+    // check nb_frags
+    if( nb_frags > CONFIG_MAPPER_MAX_FRAGMENTS )
+    {
+        printk("\n[PANIC] in %s : number of fragments cannot be larger than %d\n",
+               __FUNCTION__ , CONFIG_MAPPER_MAX_FRAGMENTS );
+        return EINVAL;
+    }
+
+    // get client cluster and local pointer on fragments array
+    cxy_t        client_cxy   = GET_CXY( xp_frags );
+    fragment_t * client_frags = (fragment_t *)GET_PTR( xp_frags );
+
+    if ( local_cxy == client_cxy ) // use the local fragments array if possible
+    {
+        frags_array = client_frags;
+    }
+    else                           // make a local copy of fragments array 
+    {
+        hal_remote_memcpy( XPTR( local_cxy , local_frags ) , xp_frags ,
+                           sizeof(fragment_t) * nb_frags );
+        frags_array = local_frags;
+    }
+
+    // loop on fragments
+    for( index = 0 ; index < nb_frags ; index ++ )
+    {
+        error = mapper_move_one_fragment( mapper , read , &frags_array[index] );
+        if ( error ) return error;
+    }
 
     return 0;
 
-}  // end mapper_move_kernel()
-
-///////////////////////////////////////////////////
-error_t mapper_remote_get_32( xptr_t     mapper_xp,
-                              uint32_t   page_id,
-                              uint32_t   word_id,
-                              uint32_t * value )
-{
-    xptr_t     page_xp;      // extended pointer on searched page descriptor
-    xptr_t     base_xp;      // extended pointer on searched page base 
-    
-    // get page containing the searched word
-    page_xp  = mapper_get_page( mapper_xp , page_id );
-
-    if( page_xp == XPTR_NULL )  return -1;
-    
-    // get page base
-    base_xp = ppm_page2base( page_xp );
-
-    // get the value from mapper
-    *value = hal_remote_l32( base_xp + (word_id<<2) ); 
-
-    return 0;
-
-}  // end mapper_remote_get_32()
-
-///////////////////////////////////////////////////
-error_t mapper_remote_set_32( xptr_t     mapper_xp,
-                              uint32_t   page_id,
-                              uint32_t   word_id,
-                              uint32_t   value )
-{
-    xptr_t     page_xp;      // extended pointer on searched page descriptor
-    xptr_t     base_xp;      // extended pointer on searched page base 
-
-    // get page containing the searched word
-    page_xp  = mapper_get_page( mapper_xp , page_id );
-
-    if( page_xp == XPTR_NULL ) return -1;
-
-    // get page base
-    base_xp = ppm_page2base( page_xp );
-
-    // set value to mapper
-    hal_remote_s32( (base_xp + (word_id << 2)) , value );
-
-    // set the dirty flag in page descriptor
-    ppm_page_do_dirty( page_xp );
-
-    return 0;
-
-}  // end mapper_remote_set_32()
-
-////////////////////////////////////////
-error_t mapper_sync( xptr_t  mapper_xp )
-{
-    uint32_t   found_key;           // unused, required by grdxt_remote_get_first()
-    error_t    error;
-
-    // get mapper cluster and local pointer
-    mapper_t * mapper_ptr = GET_PTR( mapper_xp );
-    cxy_t      mapper_cxy = GET_CXY( mapper_xp );
-
-#if DEBUG_MAPPER_SYNC
-thread_t * this  = CURRENT_THREAD;
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-char       name[CONFIG_VFS_MAX_NAME_LENGTH];
-vfs_inode_get_name( XPTR( mapper_cxy , &mapper_ptr->inode ) , name );
-#endif
-
-    // build extended pointer on radix tree
-    xptr_t   rt_xp = XPTR( mapper_cxy , &mapper_ptr->rt );
-
-    // initialise loop variable 
-    uint32_t start_key = 0;
-
-    // scan radix-tree until last page found
-    while( 1 )
-    {
-        // get page descriptor from radix tree
-        xptr_t page_xp = grdxt_remote_get_first( rt_xp , start_key , &found_key );
-         
-        page_t * page_ptr = GET_PTR( page_xp );
-
-        // exit loop when last page found
-        if( page_ptr == NULL ) break;
-
-        // get page flags & index fields
-        uint32_t flags = hal_remote_l32( XPTR( mapper_cxy , &page_ptr->flags ) );
-        uint32_t index = hal_remote_l32( XPTR( mapper_cxy , &page_ptr->index ) );
-
-        // synchronize page if dirty
-        if( flags & PG_DIRTY )
-        {
-
-#if DEBUG_MAPPER_SYNC
-if( cycle > DEBUG_MAPPER_SYNC )
-printk("\n[%s] thread[%x,%x] synchonise page %d of <%s> to IOC device\n",
-__FUNCTION__, this->process->pid, this->trdid, page_ptr->index, name );
-#endif
-            // copy page to file system
-            error = vfs_fs_move_page( page_xp , IOC_WRITE );
-
-            if( error )
-            {
-
-#if DEBUG_MAPPER_SYNC
-printk("\n[ERROR] in %s : cannot synchonize dirty page %d\n", 
-__FUNCTION__, page_ptr->index );
-#endif
-                return -1;
-            }
-
-            // remove page from PPM dirty list
-            ppm_page_undo_dirty( page_xp ); 
-        } 
-        else
-        {
-
-#if DEBUG_MAPPER_SYNC
-if( cycle > DEBUG_MAPPER_SYNC )
-printk("\n[%s] thread[%x,%x] skip page %d for <%s>\n",
-__FUNCTION__, this->process->pid, this->trdid, page_ptr->index, name );
-#endif
-        }
-
-        // update loop variable
-        start_key = index + 1;
-    }  // end while
-
-    return 0;
-
-}  // end mapper_sync()
-
-///////////////////////////////////////////////
-void mapper_display_page( xptr_t     mapper_xp,
-                          uint32_t   page_id,
-                          uint32_t   nbytes )
-{
-    char          buffer[4096];   // local buffer
-    uint32_t      line;           // line index
-    uint32_t      word;           // word index
- 
-    char       name[CONFIG_VFS_MAX_NAME_LENGTH];
-
-assert( __FUNCTION__, (nbytes <= 4096)         , "nbytes cannot be larger than 4096");
-assert( __FUNCTION__, (mapper_xp != XPTR_NULL) , "mapper_xp argument cannot be null");
-
-    // get mapper cluster and local pointer
-    cxy_t      mapper_cxy = GET_CXY( mapper_xp );
-    mapper_t * mapper_ptr = GET_PTR( mapper_xp );
-
-    // get extended pointer on page descriptor
-    xptr_t page_xp = mapper_get_page( mapper_xp , page_id );
-
-    // get page cluster and local pointer
-    cxy_t    page_cxy = GET_CXY( page_xp );
-    page_t * page_ptr = GET_PTR( page_xp );
-
-    // get page_id and mapper from page descriptor
-    uint32_t   index   = hal_remote_l32( XPTR( page_cxy , &page_ptr->index ) );
-    mapper_t * mapper  = hal_remote_lpt( XPTR( page_cxy , &page_ptr->mapper ) );
-
-assert( __FUNCTION__, (mapper_cxy == page_cxy ) , "mapper and page must be in same cluster");
-assert( __FUNCTION__, (mapper_ptr == mapper   ) , "unconsistent mapper field in page descriptor");
-assert( __FUNCTION__, (page_id    == index    ) , "unconsistent index  field in page descriptor");
-
-    // get inode
-    vfs_inode_t * inode_ptr = hal_remote_lpt( XPTR( mapper_cxy , &mapper_ptr->inode ) );
-
-    // get inode name
-    if( inode_ptr == NULL ) strcpy( name , "FAT" );
-    else  vfs_inode_get_name( XPTR( mapper_cxy , inode_ptr ) , name );
-    
-    // get extended pointer on page base
-    xptr_t base_xp = ppm_page2base( page_xp );
-   
-    // copy remote page to local buffer
-    hal_remote_memcpy( XPTR( local_cxy , buffer ) , base_xp , nbytes );
-
-    // display header
-    uint32_t * tabi = (uint32_t *)buffer;
-    printk("\n***** mapper <%s> / page_id %d / cxy %x / mapper %x / buffer %x\n",
-    name, page_id, mapper_cxy, mapper_ptr, GET_PTR( base_xp ) );
-
-    // display 8 words per line
-    for( line = 0 ; line < (nbytes >> 5) ; line++ )
-    {
-        printk("%X : ", line << 5 );
-        for( word = 0 ; word < 8 ; word++ ) printk("%X ", tabi[(line<<3) + word] );
-        printk("\n");
-    }
-
-}  // end mapper_display_page()
-
-
+}  // end mapper_move_fragments()
+
+
